// ignore_for_file: camel_case_types
// ignore_for_file: discarded_futures
// ignore_for_file: public_member_api_docs
// ignore_for_file: unreachable_switch_case

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:dynamite_runtime/built_value.dart';
import 'package:dynamite_runtime/http_client.dart';
import 'package:dynamite_runtime/utils.dart' as dynamite_utils;

part 'nested_ofs.openapi.g.dart';

class Client extends DynamiteClient {
  Client(
    super.baseURL, {
    super.baseHeaders,
    super.userAgent,
    super.httpClient,
    super.cookieJar,
  });

  Client.fromClient(final DynamiteClient client)
      : super(
          client.baseURL,
          baseHeaders: client.baseHeaders,
          httpClient: client.httpClient,
          cookieJar: client.cookieJar,
          authentications: client.authentications,
        );
}

@BuiltValue(instantiable: false)
abstract interface class BaseAllOf_1Interface {
  @BuiltValueField(wireName: 'attribute-allOf')
  String get attributeAllOf;
}

@BuiltValue(instantiable: false)
abstract interface class BaseAllOfInterface implements BaseAllOf_1Interface {
  @BuiltValueField(wireName: 'String')
  String get string;
}

abstract class BaseAllOf implements BaseAllOfInterface, Built<BaseAllOf, BaseAllOfBuilder> {
  factory BaseAllOf([final void Function(BaseAllOfBuilder)? b]) = _$BaseAllOf;

  const BaseAllOf._();

  factory BaseAllOf.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseAllOf> get serializer => _$baseAllOfSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class BaseOneOf1Interface {
  @BuiltValueField(wireName: 'attribute-oneOf')
  String get attributeOneOf;
}

abstract class BaseOneOf1 implements BaseOneOf1Interface, Built<BaseOneOf1, BaseOneOf1Builder> {
  factory BaseOneOf1([final void Function(BaseOneOf1Builder)? b]) = _$BaseOneOf1;

  const BaseOneOf1._();

  factory BaseOneOf1.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseOneOf1> get serializer => _$baseOneOf1Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class BaseAnyOf1Interface {
  @BuiltValueField(wireName: 'attribute-anyOf')
  String get attributeAnyOf;
}

abstract class BaseAnyOf1 implements BaseAnyOf1Interface, Built<BaseAnyOf1, BaseAnyOf1Builder> {
  factory BaseAnyOf1([final void Function(BaseAnyOf1Builder)? b]) = _$BaseAnyOf1;

  const BaseAnyOf1._();

  factory BaseAnyOf1.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseAnyOf1> get serializer => _$baseAnyOf1Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class BaseNestedAllOf_3Interface {
  @BuiltValueField(wireName: 'attribute-nested-allOf')
  String get attributeNestedAllOf;
}

@BuiltValue(instantiable: false)
abstract interface class BaseNestedAllOfInterface implements BaseAllOfInterface, BaseNestedAllOf_3Interface {
  @BuiltValueField(wireName: 'BaseOneOf')
  BaseOneOf get baseOneOf;
  @BuiltValueField(wireName: 'BaseAnyOf')
  BaseAnyOf get baseAnyOf;
}

abstract class BaseNestedAllOf implements BaseNestedAllOfInterface, Built<BaseNestedAllOf, BaseNestedAllOfBuilder> {
  factory BaseNestedAllOf([final void Function(BaseNestedAllOfBuilder)? b]) = _$BaseNestedAllOf;

  const BaseNestedAllOf._();

  factory BaseNestedAllOf.fromJson(final Map<String, dynamic> json) =>
      _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseNestedAllOf> get serializer => _$baseNestedAllOfSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class BaseNestedOneOf3Interface {
  @BuiltValueField(wireName: 'attribute-nested-oneOf')
  String get attributeNestedOneOf;
}

abstract class BaseNestedOneOf3 implements BaseNestedOneOf3Interface, Built<BaseNestedOneOf3, BaseNestedOneOf3Builder> {
  factory BaseNestedOneOf3([final void Function(BaseNestedOneOf3Builder)? b]) = _$BaseNestedOneOf3;

  const BaseNestedOneOf3._();

  factory BaseNestedOneOf3.fromJson(final Map<String, dynamic> json) =>
      _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseNestedOneOf3> get serializer => _$baseNestedOneOf3Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class BaseNestedAnyOf3Interface {
  @BuiltValueField(wireName: 'attribute-nested-anyOf')
  String get attributeNestedAnyOf;
}

abstract class BaseNestedAnyOf3 implements BaseNestedAnyOf3Interface, Built<BaseNestedAnyOf3, BaseNestedAnyOf3Builder> {
  factory BaseNestedAnyOf3([final void Function(BaseNestedAnyOf3Builder)? b]) = _$BaseNestedAnyOf3;

  const BaseNestedAnyOf3._();

  factory BaseNestedAnyOf3.fromJson(final Map<String, dynamic> json) =>
      _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<BaseNestedAnyOf3> get serializer => _$baseNestedAnyOf3Serializer;
}

typedef BaseOneOf = ({double? $double, BaseOneOf1? baseOneOf1});

extension BaseOneOfExtension on BaseOneOf {
  List<dynamic> get _values => [$double, baseOneOf1];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<BaseOneOf> get serializer => const _$BaseOneOfSerializer();
  static BaseOneOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$BaseOneOfSerializer implements PrimitiveSerializer<BaseOneOf> {
  const _$BaseOneOfSerializer();

  @override
  Iterable<Type> get types => const [BaseOneOf];

  @override
  String get wireName => 'BaseOneOf';

  @override
  Object serialize(
    final Serializers serializers,
    final BaseOneOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$double;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(double))!;
    }
    value = object.baseOneOf1;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseOneOf1))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  BaseOneOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    double? $double;
    try {
      $double = _jsonSerializers.deserialize(data, specifiedType: const FullType(double))! as double;
    } catch (_) {}
    BaseOneOf1? baseOneOf1;
    try {
      baseOneOf1 = _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseOneOf1))! as BaseOneOf1;
    } catch (_) {}
    return ($double: $double, baseOneOf1: baseOneOf1);
  }
}

typedef BaseAnyOf = ({int? $int, BaseAnyOf1? baseAnyOf1});

extension BaseAnyOfExtension on BaseAnyOf {
  List<dynamic> get _values => [$int, baseAnyOf1];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<BaseAnyOf> get serializer => const _$BaseAnyOfSerializer();
  static BaseAnyOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$BaseAnyOfSerializer implements PrimitiveSerializer<BaseAnyOf> {
  const _$BaseAnyOfSerializer();

  @override
  Iterable<Type> get types => const [BaseAnyOf];

  @override
  String get wireName => 'BaseAnyOf';

  @override
  Object serialize(
    final Serializers serializers,
    final BaseAnyOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$int;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(int))!;
    }
    value = object.baseAnyOf1;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseAnyOf1))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  BaseAnyOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    int? $int;
    try {
      $int = _jsonSerializers.deserialize(data, specifiedType: const FullType(int))! as int;
    } catch (_) {}
    BaseAnyOf1? baseAnyOf1;
    try {
      baseAnyOf1 = _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseAnyOf1))! as BaseAnyOf1;
    } catch (_) {}
    return ($int: $int, baseAnyOf1: baseAnyOf1);
  }
}

typedef BaseNestedOneOf = ({
  BaseAllOf? baseAllOf,
  BaseOneOf? baseOneOf,
  BaseAnyOf? baseAnyOf,
  BaseNestedOneOf3? baseNestedOneOf3
});

extension BaseNestedOneOfExtension on BaseNestedOneOf {
  List<dynamic> get _values => [baseAllOf, baseOneOf, baseAnyOf, baseNestedOneOf3];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<BaseNestedOneOf> get serializer => const _$BaseNestedOneOfSerializer();
  static BaseNestedOneOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$BaseNestedOneOfSerializer implements PrimitiveSerializer<BaseNestedOneOf> {
  const _$BaseNestedOneOfSerializer();

  @override
  Iterable<Type> get types => const [BaseNestedOneOf];

  @override
  String get wireName => 'BaseNestedOneOf';

  @override
  Object serialize(
    final Serializers serializers,
    final BaseNestedOneOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.baseAllOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseAllOf))!;
    }
    value = object.baseOneOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseOneOf))!;
    }
    value = object.baseAnyOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseAnyOf))!;
    }
    value = object.baseNestedOneOf3;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseNestedOneOf3))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  BaseNestedOneOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    BaseAllOf? baseAllOf;
    try {
      baseAllOf = _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseAllOf))! as BaseAllOf;
    } catch (_) {}
    BaseOneOf? baseOneOf;
    try {
      baseOneOf = ((_jsonSerializers.deserialize(data, specifiedType: const FullType(BaseOneOf))! as BaseOneOf)
        ..validateOneOf());
    } catch (_) {}
    BaseAnyOf? baseAnyOf;
    try {
      baseAnyOf = ((_jsonSerializers.deserialize(data, specifiedType: const FullType(BaseAnyOf))! as BaseAnyOf)
        ..validateAnyOf());
    } catch (_) {}
    BaseNestedOneOf3? baseNestedOneOf3;
    try {
      baseNestedOneOf3 =
          _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseNestedOneOf3))! as BaseNestedOneOf3;
    } catch (_) {}
    return (baseAllOf: baseAllOf, baseOneOf: baseOneOf, baseAnyOf: baseAnyOf, baseNestedOneOf3: baseNestedOneOf3);
  }
}

typedef BaseNestedAnyOf = ({
  BaseAllOf? baseAllOf,
  BaseOneOf? baseOneOf,
  BaseAnyOf? baseAnyOf,
  BaseNestedAnyOf3? baseNestedAnyOf3
});

extension BaseNestedAnyOfExtension on BaseNestedAnyOf {
  List<dynamic> get _values => [baseAllOf, baseOneOf, baseAnyOf, baseNestedAnyOf3];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<BaseNestedAnyOf> get serializer => const _$BaseNestedAnyOfSerializer();
  static BaseNestedAnyOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$BaseNestedAnyOfSerializer implements PrimitiveSerializer<BaseNestedAnyOf> {
  const _$BaseNestedAnyOfSerializer();

  @override
  Iterable<Type> get types => const [BaseNestedAnyOf];

  @override
  String get wireName => 'BaseNestedAnyOf';

  @override
  Object serialize(
    final Serializers serializers,
    final BaseNestedAnyOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.baseAllOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseAllOf))!;
    }
    value = object.baseOneOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseOneOf))!;
    }
    value = object.baseAnyOf;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseAnyOf))!;
    }
    value = object.baseNestedAnyOf3;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(BaseNestedAnyOf3))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  BaseNestedAnyOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    BaseAllOf? baseAllOf;
    try {
      baseAllOf = _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseAllOf))! as BaseAllOf;
    } catch (_) {}
    BaseOneOf? baseOneOf;
    try {
      baseOneOf = ((_jsonSerializers.deserialize(data, specifiedType: const FullType(BaseOneOf))! as BaseOneOf)
        ..validateOneOf());
    } catch (_) {}
    BaseAnyOf? baseAnyOf;
    try {
      baseAnyOf = ((_jsonSerializers.deserialize(data, specifiedType: const FullType(BaseAnyOf))! as BaseAnyOf)
        ..validateAnyOf());
    } catch (_) {}
    BaseNestedAnyOf3? baseNestedAnyOf3;
    try {
      baseNestedAnyOf3 =
          _jsonSerializers.deserialize(data, specifiedType: const FullType(BaseNestedAnyOf3))! as BaseNestedAnyOf3;
    } catch (_) {}
    return (baseAllOf: baseAllOf, baseOneOf: baseOneOf, baseAnyOf: baseAnyOf, baseNestedAnyOf3: baseNestedAnyOf3);
  }
}

// coverage:ignore-start
final Serializers _serializers = (Serializers().toBuilder()
      ..addBuilderFactory(const FullType(BaseAllOf), BaseAllOf.new)
      ..add(BaseAllOf.serializer)
      ..addBuilderFactory(const FullType(BaseOneOf1), BaseOneOf1.new)
      ..add(BaseOneOf1.serializer)
      ..add(BaseOneOfExtension.serializer)
      ..addBuilderFactory(const FullType(BaseAnyOf1), BaseAnyOf1.new)
      ..add(BaseAnyOf1.serializer)
      ..add(BaseAnyOfExtension.serializer)
      ..addBuilderFactory(const FullType(BaseNestedAllOf), BaseNestedAllOf.new)
      ..add(BaseNestedAllOf.serializer)
      ..addBuilderFactory(const FullType(BaseNestedOneOf3), BaseNestedOneOf3.new)
      ..add(BaseNestedOneOf3.serializer)
      ..add(BaseNestedOneOfExtension.serializer)
      ..addBuilderFactory(const FullType(BaseNestedAnyOf3), BaseNestedAnyOf3.new)
      ..add(BaseNestedAnyOf3.serializer)
      ..add(BaseNestedAnyOfExtension.serializer))
    .build();

final Serializers _jsonSerializers = (_serializers.toBuilder()
      ..add(DynamiteDoubleSerializer())
      ..addPlugin(StandardJsonPlugin())
      ..addPlugin(const ContentStringPlugin()))
    .build();
// coverage:ignore-end
