// ignore_for_file: camel_case_types
// ignore_for_file: discarded_futures
// ignore_for_file: public_member_api_docs
// ignore_for_file: unreachable_switch_case

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:dynamite_runtime/built_value.dart';
import 'package:dynamite_runtime/http_client.dart';
import 'package:dynamite_runtime/utils.dart' as dynamite_utils;

part 'one_of.openapi.g.dart';

class Client extends DynamiteClient {
  Client(
    super.baseURL, {
    super.baseHeaders,
    super.userAgent,
    super.httpClient,
    super.cookieJar,
  });

  Client.fromClient(final DynamiteClient client)
      : super(
          client.baseURL,
          baseHeaders: client.baseHeaders,
          httpClient: client.httpClient,
          cookieJar: client.cookieJar,
          authentications: client.authentications,
        );
}

@BuiltValue(instantiable: false)
abstract interface class ObjectOneOf0Interface {
  @BuiltValueField(wireName: 'attribute1-oneOf')
  String get attribute1OneOf;
}

abstract class ObjectOneOf0 implements ObjectOneOf0Interface, Built<ObjectOneOf0, ObjectOneOf0Builder> {
  factory ObjectOneOf0([final void Function(ObjectOneOf0Builder)? b]) = _$ObjectOneOf0;

  const ObjectOneOf0._();

  factory ObjectOneOf0.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<ObjectOneOf0> get serializer => _$objectOneOf0Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class ObjectOneOf1Interface {
  @BuiltValueField(wireName: 'attribute2-oneOf')
  String get attribute2OneOf;
}

abstract class ObjectOneOf1 implements ObjectOneOf1Interface, Built<ObjectOneOf1, ObjectOneOf1Builder> {
  factory ObjectOneOf1([final void Function(ObjectOneOf1Builder)? b]) = _$ObjectOneOf1;

  const ObjectOneOf1._();

  factory ObjectOneOf1.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<ObjectOneOf1> get serializer => _$objectOneOf1Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class MixedOneOf1Interface {
  @BuiltValueField(wireName: 'attribute-oneOf')
  String get attributeOneOf;
}

abstract class MixedOneOf1 implements MixedOneOf1Interface, Built<MixedOneOf1, MixedOneOf1Builder> {
  factory MixedOneOf1([final void Function(MixedOneOf1Builder)? b]) = _$MixedOneOf1;

  const MixedOneOf1._();

  factory MixedOneOf1.fromJson(final Map<String, dynamic> json) => _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<MixedOneOf1> get serializer => _$mixedOneOf1Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class OneObjectOneOf0Interface {
  @BuiltValueField(wireName: 'attribute-oneOf')
  String get attributeOneOf;
}

abstract class OneObjectOneOf0 implements OneObjectOneOf0Interface, Built<OneObjectOneOf0, OneObjectOneOf0Builder> {
  factory OneObjectOneOf0([final void Function(OneObjectOneOf0Builder)? b]) = _$OneObjectOneOf0;

  const OneObjectOneOf0._();

  factory OneObjectOneOf0.fromJson(final Map<String, dynamic> json) =>
      _jsonSerializers.deserializeWith(serializer, json)!;

  Map<String, dynamic> toJson() => _jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;

  static Serializer<OneObjectOneOf0> get serializer => _$oneObjectOneOf0Serializer;
}

typedef ObjectOneOf = ({ObjectOneOf0? objectOneOf0, ObjectOneOf1? objectOneOf1});

extension ObjectOneOfExtension on ObjectOneOf {
  List<dynamic> get _values => [objectOneOf0, objectOneOf1];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<ObjectOneOf> get serializer => const _$ObjectOneOfSerializer();
  static ObjectOneOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$ObjectOneOfSerializer implements PrimitiveSerializer<ObjectOneOf> {
  const _$ObjectOneOfSerializer();

  @override
  Iterable<Type> get types => const [ObjectOneOf];

  @override
  String get wireName => 'ObjectOneOf';

  @override
  Object serialize(
    final Serializers serializers,
    final ObjectOneOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.objectOneOf0;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(ObjectOneOf0))!;
    }
    value = object.objectOneOf1;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(ObjectOneOf1))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  ObjectOneOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    ObjectOneOf0? objectOneOf0;
    try {
      objectOneOf0 = _jsonSerializers.deserialize(data, specifiedType: const FullType(ObjectOneOf0))! as ObjectOneOf0;
    } catch (_) {}
    ObjectOneOf1? objectOneOf1;
    try {
      objectOneOf1 = _jsonSerializers.deserialize(data, specifiedType: const FullType(ObjectOneOf1))! as ObjectOneOf1;
    } catch (_) {}
    return (objectOneOf0: objectOneOf0, objectOneOf1: objectOneOf1);
  }
}

typedef MixedOneOf = ({String? string, MixedOneOf1? mixedOneOf1});

extension MixedOneOfExtension on MixedOneOf {
  List<dynamic> get _values => [string, mixedOneOf1];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<MixedOneOf> get serializer => const _$MixedOneOfSerializer();
  static MixedOneOf fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$MixedOneOfSerializer implements PrimitiveSerializer<MixedOneOf> {
  const _$MixedOneOfSerializer();

  @override
  Iterable<Type> get types => const [MixedOneOf];

  @override
  String get wireName => 'MixedOneOf';

  @override
  Object serialize(
    final Serializers serializers,
    final MixedOneOf object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.string;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(String))!;
    }
    value = object.mixedOneOf1;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(MixedOneOf1))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  MixedOneOf deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    String? string;
    try {
      string = _jsonSerializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    MixedOneOf1? mixedOneOf1;
    try {
      mixedOneOf1 = _jsonSerializers.deserialize(data, specifiedType: const FullType(MixedOneOf1))! as MixedOneOf1;
    } catch (_) {}
    return (string: string, mixedOneOf1: mixedOneOf1);
  }
}

typedef OneObjectOneOf = OneObjectOneOf0;

typedef OneValueOneOf = String;

typedef OneOfIntDouble = num;

typedef OneOfIntDoubleNum = num;

typedef OneOfIntDoubleOther = ({num? $num, String? string});

extension OneOfIntDoubleOtherExtension on OneOfIntDoubleOther {
  List<dynamic> get _values => [$num, string];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<OneOfIntDoubleOther> get serializer => const _$OneOfIntDoubleOtherSerializer();
  static OneOfIntDoubleOther fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$OneOfIntDoubleOtherSerializer implements PrimitiveSerializer<OneOfIntDoubleOther> {
  const _$OneOfIntDoubleOtherSerializer();

  @override
  Iterable<Type> get types => const [OneOfIntDoubleOther];

  @override
  String get wireName => 'OneOfIntDoubleOther';

  @override
  Object serialize(
    final Serializers serializers,
    final OneOfIntDoubleOther object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$num;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(num))!;
    }
    value = object.string;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(String))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  OneOfIntDoubleOther deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    num? $num;
    try {
      $num = _jsonSerializers.deserialize(data, specifiedType: const FullType(num))! as num;
    } catch (_) {}
    String? string;
    try {
      string = _jsonSerializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    return ($num: $num, string: string);
  }
}

// coverage:ignore-start
final Serializers _serializers = (Serializers().toBuilder()
      ..addBuilderFactory(const FullType(ObjectOneOf0), ObjectOneOf0.new)
      ..add(ObjectOneOf0.serializer)
      ..addBuilderFactory(const FullType(ObjectOneOf1), ObjectOneOf1.new)
      ..add(ObjectOneOf1.serializer)
      ..add(ObjectOneOfExtension.serializer)
      ..addBuilderFactory(const FullType(MixedOneOf1), MixedOneOf1.new)
      ..add(MixedOneOf1.serializer)
      ..add(MixedOneOfExtension.serializer)
      ..addBuilderFactory(const FullType(OneObjectOneOf0), OneObjectOneOf0.new)
      ..add(OneObjectOneOf0.serializer)
      ..add(OneOfIntDoubleOtherExtension.serializer))
    .build();

final Serializers _jsonSerializers = (_serializers.toBuilder()
      ..add(DynamiteDoubleSerializer())
      ..addPlugin(StandardJsonPlugin())
      ..addPlugin(const ContentStringPlugin()))
    .build();
// coverage:ignore-end
