// ignore_for_file: camel_case_types
// ignore_for_file: discarded_futures
// ignore_for_file: public_member_api_docs
// ignore_for_file: unreachable_switch_case

import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:dynamite_runtime/built_value.dart';
import 'package:dynamite_runtime/http_client.dart';
import 'package:dynamite_runtime/utils.dart' as dynamite_utils;

class Client extends DynamiteClient {
  Client(
    super.baseURL, {
    super.baseHeaders,
    super.userAgent,
    super.httpClient,
    super.cookieJar,
  });

  Client.fromClient(final DynamiteClient client)
      : super(
          client.baseURL,
          baseHeaders: client.baseHeaders,
          httpClient: client.httpClient,
          cookieJar: client.cookieJar,
          authentications: client.authentications,
        );
}

typedef OneOfIntDoubleOther = ({num? $num, String? string});

extension OneOfIntDoubleOtherExtension on OneOfIntDoubleOther {
  List<dynamic> get _values => [$num, string];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<OneOfIntDoubleOther> get serializer => const _$OneOfIntDoubleOtherSerializer();
  static OneOfIntDoubleOther fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$OneOfIntDoubleOtherSerializer implements PrimitiveSerializer<OneOfIntDoubleOther> {
  const _$OneOfIntDoubleOtherSerializer();

  @override
  Iterable<Type> get types => const [OneOfIntDoubleOther];

  @override
  String get wireName => 'OneOfIntDoubleOther';

  @override
  Object serialize(
    final Serializers serializers,
    final OneOfIntDoubleOther object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$num;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(num))!;
    }
    value = object.string;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(String))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  OneOfIntDoubleOther deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    num? $num;
    try {
      $num = _jsonSerializers.deserialize(data, specifiedType: const FullType(num))! as num;
    } catch (_) {}
    String? string;
    try {
      string = _jsonSerializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    return ($num: $num, string: string);
  }
}

typedef AnyOfIntDoubleOther = ({num? $num, String? string});

extension AnyOfIntDoubleOtherExtension on AnyOfIntDoubleOther {
  List<dynamic> get _values => [$num, string];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<AnyOfIntDoubleOther> get serializer => const _$AnyOfIntDoubleOtherSerializer();
  static AnyOfIntDoubleOther fromJson(final Object? json) => _jsonSerializers.deserializeWith(serializer, json)!;
  Object? toJson() => _jsonSerializers.serializeWith(serializer, this);
}

class _$AnyOfIntDoubleOtherSerializer implements PrimitiveSerializer<AnyOfIntDoubleOther> {
  const _$AnyOfIntDoubleOtherSerializer();

  @override
  Iterable<Type> get types => const [AnyOfIntDoubleOther];

  @override
  String get wireName => 'AnyOfIntDoubleOther';

  @override
  Object serialize(
    final Serializers serializers,
    final AnyOfIntDoubleOther object, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$num;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(num))!;
    }
    value = object.string;
    if (value != null) {
      return _jsonSerializers.serialize(value, specifiedType: const FullType(String))!;
    } // Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  AnyOfIntDoubleOther deserialize(
    final Serializers serializers,
    final Object data, {
    final FullType specifiedType = FullType.unspecified,
  }) {
    num? $num;
    try {
      $num = _jsonSerializers.deserialize(data, specifiedType: const FullType(num))! as num;
    } catch (_) {}
    String? string;
    try {
      string = _jsonSerializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    return ($num: $num, string: string);
  }
}

// coverage:ignore-start
final Serializers _serializers = (Serializers().toBuilder()
      ..add(OneOfIntDoubleOtherExtension.serializer)
      ..add(AnyOfIntDoubleOtherExtension.serializer))
    .build();

final Serializers _jsonSerializers = (_serializers.toBuilder()
      ..add(DynamiteDoubleSerializer())
      ..addPlugin(StandardJsonPlugin())
      ..addPlugin(const ContentStringPlugin()))
    .build();
// coverage:ignore-end
